class EurekaBot::Session

  attr_reader :key, :redis

  def initialize(key, redis: nil)
    @key   = key
    @redis = redis
  end

  def update(**attributes)
    self.data = data.merge(attributes.deep_symbolize_keys).compact
  end

  def data
    @data ||= get || {}
  end

  def data=(v)
    @data = v
    set
  end

  def get
    got = redis.get(key)
    got.present? ? ActiveSupport::JSON.decode(got).deep_symbolize_keys : nil
  end

  def set
    redis.set(key, data.to_json) == 'OK'
  end

  def del
    redis.del(key)
  end

end
